//-----------------------------------------------------------------------------
// Init
//-----------------------------------------------------------------------------

const cluster = require('cluster');
const numCPUs = 2//require('os').cpus().length;

//-----------------------------------------------------------------------------
// Main
//-----------------------------------------------------------------------------

startCluster = function( startClusterCallback ){

  var setUpOneFork = function(){
    var worker = cluster.fork();

    /// bind the messaging between each worker and the master
    worker.on('message', function(msg){
      console.log('http-cluster.js - worker.on message', msg)

      //#set external kill switch
      //msg contains the processId
      //means the worker has started a sandbox
      //if time runs out, kill the process (cannot kill reliably within process)
      var timeoutID
      if(  !isNaN( msg ) ){
        timeoutID = setTimeout(function(){
           //kills itself
           process.kill( msg )
        }, 1000 );
      }

      if( msg === "clearTimeout" ){
        clearTimeout( timeoutID )
      }

      ///when at least one worker http server is listening.
      if ( msg === 'ready' && startClusterCallback ){
        // return that at least one server is running.
        startClusterCallback()
        //run once, empty the function
        startClusterCallback = function(){}
      }
    });

    worker.on('exit', function(code, signal){

      console.log('http-cluster.js - worker '+ worker.process.pid +' died.');
      //start a new worker
      var newWorker = setUpOneFork() //cluster.fork();
      console.log('http-cluster.js - worker '+ newWorker.process.pid + ' born.');
    });

    return worker
  }


  cluster.setupMaster({
    exec: __dirname + '/http-worker.js'
  });

  if (cluster.isMaster) {
    // CREATE A CLUSTER OF FORKED SCRIPTS, ONE PER CPU
    for ( var i = 0; i < numCPUs; i++ ) {
      setUpOneFork()
    }
  }

  return process.pid
}

// startCluster()

// startCluster( function(){
//   console.log('hello');
// })
// startCluster()

//-----------------------------------------------------------------------------
// EXPORTS
//-----------------------------------------------------------------------------


module.exports = startCluster;
